<template>
	<div class="w-full px-2 md:px-4">
		<MkPageSpinner v-if="SHOW_PAGE_SPINNER" />
		<div class="flex mb-8 md:mb-6 lg:mb-8">
			<div class="flex mr-4">
				<div role="img" :aria-label="product_name" class="flex items-start justify-center">
					<MKProductImage size-class="w-17 h-17" :product-detail="item" />
				</div>
			</div>
			<div class="flex flex-col w-full text-black">
				<div class="flex justify-between relative">
					<div>
						<h4 id="mk-prt-nm" class="text-xl font-secondary-font-regular leading-6">
							{{ product_name }}
						</h4>
						<MKFilterSubscription v-if="FEATURE_SUBSCRIPTION" :item="item" :show-tooltip="true" />
					</div>
					<div class="flex flex-col relative">
						<MkActualPrice v-show="item.priceDisplay.strikePrice > 0" :actual-price="item.priceDisplay.strikePrice" />
						<div v-if="item.priceDisplay.strikePrice > 0" class="flex justify-end text-base font-primary-font-regular">
							{{ currencyDisplay }}{{ item.priceDisplay.price | centsToDollars | formatPrice }}
						</div>
						<div v-else class="flex justify-end text-base font-primary-font-regular">
							{{ currencyDisplay }}{{ (item.quantity * item.price.value['centAmount']) | centsToDollars | formatPrice }}
						</div>
					</div>
				</div>
				<div class="flex justify-between">
					<MkQuantityDropdown
						id="side_cart_qty"
						:aria-label="product_name"
						:value="item.quantity"
						@change="updateQuantity($event)"
					/>
					<div class="text-gray-500 flex z-10">
						<button aria-label="Close" @click="removeFullLineItem">
							<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 12 11" class="w-3 h-3 fill-current">
								<g fill="none" fill-rule="evenodd">
									<g fill="#D7D5D4">
										<g>
											<g>
												<g>
													<path
														d="M10.125 3.25c.552 0 1 .448 1 1l-.001 4.624 4.626.001c.552 0 1 .448 1 1v.25c0 .552-.448 1-1 1l-4.626-.001.001 4.626c0 .552-.448 1-1 1h-.25c-.552 0-1-.448-1-1l-.001-4.626-4.624.001c-.552 0-1-.448-1-1v-.25c0-.552.448-1 1-1l4.624-.001.001-4.624c0-.552.448-1 1-1h.25z"
														transform="translate(-345 -363) translate(15 268) translate(92 89.554) translate(234 .661) rotate(45 10 10)"
													></path>
												</g>
											</g>
										</g>
									</g>
								</g>
							</svg>
						</button>
					</div>
				</div>
			</div>
		</div>
		<div class="-mt-6 mb-8 md:mb-6 lg:mb-8" v-if="FEATURE_CLYDE">
			<MkClydeButton :is-side-cart="true" :item="item" />
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkClydeButton from '~/components/D2C/atoms/MkClydeButton.vue';
import MkActualPrice from '~/components/D2C/atoms/MkActualPrice.vue';
import MkQuantityDropdown from '~/components/D2C/molecules/MkQuantityDropdown/MkQuantityDropdown.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
import MKFilterSubscription from '~/components/D2C/molecules/MkFilterSubscription/MkFilterSubscription.vue';
import MkPageSpinner from '~/components/D2C/atoms/MkPageSpinner/MkPageSpinner.vue';
export default {
	name: 'MkCartCard',
	components: {
		MkQuantityDropdown,
		MkClydeButton,
		MkActualPrice,
		MKProductImage,
		MKFilterSubscription,
		MkPageSpinner,
	},
	props: {
		item: {
			type: [Object, String, Array],
			default() {
				return {};
			},
		},
	},
	data() {
		return {
			productImg: '',
			hasQuote: false,
			actualPrice: '',
			quantity: 0,
		};
	},
	computed: {
		product_name() {
			return this.item.name ? this.item.name[this.apiLocale] : 'Product Name';
		},
		...mapState(['currencyDisplay','apiLocale']),
		...mapState('USER_STORE', ['AUTHENTICATED', 'CUSTOMERID', 'CUSTOMER_DETAILS_D2C_TEALIUM']),
		...mapState('CART_STORE', ['CART_ID', 'LINE_ITEMS', 'DISCOUNT_PRICE', 'SUB_TOTAL_PRICE']),
		...mapState('CHECKOUT_STORE', ['SHOW_PAGE_SPINNER', 'FEATURE_CLYDE', 'FEATURE_SUBSCRIPTION']),
		isAuthenticatedUser() {
			return this.AUTHENTICATED;
		},
	},
	async mounted() {},
	methods: {
		async removeFullLineItem() {
			try {
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
				const newProductPayload = {
					action: 'REMOVE_LINE_ITEM',
					lineItemId: this.item.id,
					quantity: this.item.quantity,
					skuId: '',
				};
				await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', newProductPayload);
				this.cartOperation('remove');
				this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			} catch (error) {
				// move to global error handler
				// console.log(error)
			}
		},
		async updateQuantity(value) {
			if (this.item) {
				if (!value) {
					this.removeFullLineItem();
				} else {
					try {
						this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
						if (value > this.item.quantity) {
							this.cartOperation('increase');
						} else {
							this.cartOperation('decrease');
						}
						const newProductPayload = {
							action: 'CHANGE_LINE_ITEM_QTY',
							lineItemId: this.item.id,
							productId: this.item.productId || null,
							quantity: value,
							skuId: '',
						};
						await this.$store.dispatch('CART_STORE/ADD_REMOVE_FROM_CART', newProductPayload);
					} catch (error) {
						// move to global error handler
						// console.log(error)
					} finally {
						this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
					}
				}
			}
		},
		async cartOperation(key) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const tealiumPayload = {
				page_type: 'cart',
				cart_id: this.CART_ID,
				cart_product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				cart_product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				cart_product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				cart_total_items: this.LINE_ITEMS.length.toFixed(0),
				cart_total_value: this.$root.$utility.centsToDollarsConvert(this.SUB_TOTAL_PRICE),
				cart_discount: [this.$root.$utility.centsToDollarsConvert(this.DISCOUNT_PRICE)],
				product_brand: [...new Set(this.LINE_ITEMS.map((x) => x.product_brand || 'Molekule'))],
				product_category: [...new Set(this.LINE_ITEMS.map((x) => x.productType?.obj?.name || 'Filters'))],
				product_discount_amount: [...new Set(this.LINE_ITEMS.map((x) => x.product_discount_amount || '0'))],
				product_name: [...new Set(this.LINE_ITEMS.map((x) => x.name[this.apiLocale]))],
				product_promo_code: '',
				product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				product_in_stock: [...new Set(this.LINE_ITEMS.map((x) => x.productStockCount || ''))],
				product_plan_details: [...new Set(this.LINE_ITEMS.map((x) => x.cartItemSubscriptionData?.productPlan || ''))],
				product_renewal_date: [...new Set(this.LINE_ITEMS.map((x) => x.cartItemSubscriptionData?.nextRefill || ''))],
				product_review_stars: [...new Set(this.LINE_ITEMS.map((x) => x.averageRating || '1'))],
				event_category: 'Cart',
				...customerDetails,
			};
			const productImgUrl = [];
			for (let i = 0; i < this.LINE_ITEMS.length; i++) {
				productImgUrl.push(await this.$root.$getImage(this.LINE_ITEMS[i]?.variant?.sku));
			}
			tealiumPayload.product_image_url = productImgUrl;
			const listPriceArray = [];
			const productListPrice = [...new Set(this.LINE_ITEMS.map((x) => x.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPriceArray.push(this.$root.$utility.centsToDollarsConvert(el.value.centAmount, el.value.fractionDigits));
				}
			});
			tealiumPayload.cart_product_price = listPriceArray;
			tealiumPayload.productListPrice = listPriceArray;
			tealiumPayload.productListPrice = listPriceArray;
			tealiumPayload.product_price = listPriceArray;
			if (key === 'increase') {
				tealiumPayload.event_action = 'Changed Quantity';
				tealiumPayload.event_label = 'Increased';
				tealiumPayload.event_value = [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('quantity_increase', tealiumPayload);
			} else if (key === 'decrease') {
				tealiumPayload.event_action = 'Changed Quantity';
				tealiumPayload.event_label = 'Decreased';
				tealiumPayload.event_value = [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('quantity_decrease', tealiumPayload);
			} else if (key === 'remove') {
				tealiumPayload.event_action = 'Removed from Cart';
				tealiumPayload.event_label = 'Removed :' + [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))];
				this.$root.$telium.setTealiumPayload('cart_remove', tealiumPayload);
			}
		},
	},
};
</script>

<style>
.icon-notification:hover::before {
	@apply text-black;
}
</style>
